
-- mb900
-- Specialization for mb900 mod
-- Date 19/07/2015
-- Copyright (C) Unguided


mb900 = {};

function mb900.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function mb900:load(savegame)
    self.frontLinkageBottomArmRotNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.frontBottomArm#visNode"));
    setVisibility(self.frontLinkageBottomArmRotNode, false) ;
end;

function mb900:delete()
end;

function mb900:readStream(streamId, connection)
end;

function mb900:writeStream(streamId, connection)
end;

function mb900:mouseEvent(posX, posY, isDown, isUp, button)
end;

function mb900:keyEvent(unicode, sym, modifier, isDown)
end;

function mb900:update(dt)
end;

function mb900:updateTick(dt)
end;

function mb900:draw()
end;

function mb900:onLeave()
end;

function mb900:onEnter()
end;

function mb900:attachImplement(implement)
    local jointType = implement.object.attacherJoint.jointType;
    local jointIndex = implement.jointDescIndex;

    if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = math.max(self.self.implementCount - 1, 0);
        end;
        if jointIndex == 2 then
            setVisibility(self.frontLinkageBottomArmRotNode, true);
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILER then
        if jointIndex == 3 then
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
        if jointIndex == 4 then
        end;
    end;

    self.updateJoint = true;
end;

function mb900:detachImplement(implementIndex)
    local implement = self.attachedImplements[implementIndex];
    local jointIndex = implement.jointDescIndex;

    if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = self.implementCount + 1;
        end;
        if jointIndex == 2 then
            setVisibility(self.frontLinkageBottomArmRotNode, false);
        end;
    else
    end;

    self.updateJoint = true;
end;

function mb900:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
